#
# orderedhash.rb
#

class OrderedHash

  include Enumerable

  def OrderedHash.new_from_alist( alist )
    t = self.new
    alist.each do |k,v|
      t[k] = v
    end
    t
  end

  def initialize( list = [] )
    @hash = {}
    @list = list.dup
    @list.each do |i|
      @hash[i] = i
    end
  end

  def size
    @list.size
  end

  def []=( key, val )
    unless @hash.key? key then
      @hash[key] = val
      @list.push key
    else
      @hash[key] = val
    end
    val
  end
  
  def []( name )
    @hash[name]
  end

  def key?( name )
    @hash.key? name
  end

  def keys
    @list.dup
  end

  def delete( key )
    @list.delete key
    @hash.delete key
  end

  def each
    @list.each do |key|
      yield key, @hash[key]
    end
  end

  def each_key( &block )
    @list.each(&block)
  end

  def each_value
    @list.each do |k|
      yield @hash[k]
    end
  end

  def dup
    t = self.class.new(@list)
    h = @hash.dup
    t.instance_eval { @hash = h }
    t
  end

  def reject!
    @list.dup.each do |k|
      delete k if yield(k,@hash[k])
    end
  end

  alias delete_if reject!

end
